
/***************************************************************************
 ratshooter: a simple shooter!
 Version: 0.1
 Written in Qt 4.3 

    copyright            : (C) by Dimitris B. Kalamaras
    email                : dimitris.kalamaras@gmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/



#include <QtGui/QGraphicsView>
#include <QGraphicsScene>
#include "canvas.h"
#include <math.h>
#include "mouse.h"
static const int MouseCount = 7;

Canvas::Canvas() {
  QGraphicsScene *scene = new QGraphicsScene(this);
  scene->setItemIndexMethod(QGraphicsScene::NoIndex);
  scene->setSceneRect(-200,-200, 400, 400);
  setScene(scene);
  setRenderHint(QPainter::Antialiasing);
  setBackgroundBrush(QPixmap(":/images/cheese.jpg"));
  setCacheMode(QGraphicsView::CacheBackground);
  setDragMode(QGraphicsView::ScrollHandDrag);

  for (int i = 0; i < MouseCount; ++i) {
    Mouse *mouse = new Mouse;
    mouse->setPos(-200+qrand() % 400, -200+qrand() % 400);
    scene->addItem(mouse);
    connect(mouse, SIGNAL(destroyed()), this, SLOT(showScore()));
  }
  setMinimumSize(600, 500);
}



void Canvas::showScore(){
  QList<QGraphicsTextItem *> texts;
  foreach (QGraphicsItem *item, scene()->items()) {
    if (QGraphicsTextItem *text = qgraphicsitem_cast<QGraphicsTextItem *>(item))
     texts << text;
  }
  foreach (QGraphicsTextItem *text, texts)
    scene()->removeItem(text);
  QString message("Shoot' em up! \nRats left: ");
  message +=QString::number(scene()->items().count());
  QFont font;
  font.setBold(true);
  font.setPointSize(14);
  QGraphicsTextItem *text;
  text=scene()->addText(message, font); 
  text->setPos(-300,200);
}

void Canvas::runMiceRun(){
  QList<Mouse *> mice;
  foreach (QGraphicsItem *item, scene()->items()) {
    if (Mouse *mouse= qgraphicsitem_cast<Mouse *>(item))
      mice<< mouse;
    }
  qDebug("START!");
  showScore();
  foreach (Mouse *mouse, mice)
    mouse->startTimer(1000 / 33);
}
