
/***************************************************************************
 ratshooter: a simple shooter!
 Version: 0.1
 Written in Qt 4.3 

    copyright            : (C) by Dimitris B. Kalamaras
    email                : dimitris.kalamaras@gmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <QGraphicsScene>
#include <QGraphicsSceneMouseEvent>
#include <QPainter>
#include <QStyleOption>
#include <math.h>
#include <QtGlobal>
#include <QApplication>
static const double Pi = 3.14159265;


Mouse::Mouse()  {
  rotate(qrand() % (360 * 16));
  QImage image(":/images/cursor.png");
  setCursor(QCursor(QPixmap::fromImage(image)));
}

QRectF Mouse::boundingRect() const {
  qreal adjust = 0.5;
  return QRectF(-20 - adjust, -22 - adjust, 100 + adjust, 90 + adjust);
}


void Mouse::paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *) {
  QImage image(":/images/rat.png");
  painter->drawPixmap(QPointF(0,0), QPixmap::fromImage(image));
  if (pos().x() <= -250) setPos ( 0,0);
  if (pos().x() >= 300) setPos ( 0,0);
  if (pos().y() <= -250) setPos ( 0,0);
  if (pos().y() >= 300) setPos ( 0,0);

}

void Mouse::timerEvent(QTimerEvent *) {
  speed += (-50 + qrand() % 100) / 100.0;
  angle = (qrand() % 100) / 500.0;
  qreal dx = ::sin(angle) * 10;
  rotate(dx);
  setPos(mapToParent(0, -(3 + sin(speed) * 3))); 
}


void Mouse::mousePressEvent(QGraphicsSceneMouseEvent *event) {  
    scene()->removeItem(this);
    emit destroyed();
    return;
}
